BEGIN {
  print "digraph GC {";
  print "  size=\"4,4\";";
  print "  rankdir=LR;";
  print "  node [shape=box];";
  print "  ";
  node_number = 0;
  link_number = 0;
}
{
  n = split ($0, x, "<");

  sub ("<", "", $1);
  sub (">", "", $1);

  if (x[1] == "Class")
  {
    sub ("[(]", "", $3);
    if ($3 > 0)
      {
	# print "  " $2 ";";
      }
  }
  else if (x[1] == "Object")
  {
    sub (".*[=]", "", $4);
    split ($4, w, ":");

    ###print "  ----> Object [" $4 "]: " w[2] w[1];

    object_address = $1;
    sub ("Object", "", object_address);
    object[$4] = object_address;
    object_name[$4] = $4;
  }
  else if (x[1] == "Reference")
  {
    o1 = $5;
    o2 = $7;

    sub ("^.", "", o1);
    sub (".$", "", o1);
    sub ("^.", "", o2);
    sub (".$", "", o2);

    c1 = o1;
    c2 = o2;

    sub (".*:", "", c1);
    sub (".*:", "", c2);

    ###print "/* c1=" c1 " c2=" c2 "*/"; 

    if (c1 == "")
      {
	if (c2 != "Class")
	  {
	    ground++;
	    o1 = ground ":Ground";
	    node[node_number] = o1; node_number++;
	    object_name[o1] = o1;
	    node[node_number] = o2; node_number++;
	    link_number++;
	  }
      }
    else
      {
	if ((c1 == "Hasher") && (c2 == "Array"))
	  {
	    print " /* convert " o2 " to " o1 " */";
	    object_name[o2] = object_name[o1];
	  }
	else
	  {
	    node[node_number] = o1; node_number++;
	    node[node_number] = o2; node_number++;
	    link_number++;
	  }
      }
  }
}
END {
  j = 0;
  for (i = 0; i < link_number; i++)
    {
      o1 = node[j]; j++;
      o2 = node[j]; j++;

      printf " /* o1=" o1 " o2=" o2;

      o1 = object_name[o1];
      o2 = object_name[o2];

      print " -> o1=" o1 " o2=" o2 "*/";

      c1 = o1;
      c2 = o2;

      sub (".*:", "", c1);
      sub (".*:", "", c2);

      if (c1 == "Ground")
	{
	  print "\"" o1 "\" [label = \"G\", shape = ellipse];"; 
	  print "\"" o2 "\" [label = \"" c2 "\\n" object[o2] "\"];"; 
	  print "\"" o1 "\" -> \"" o2 "\";"; 
	}
      else
	{
	  print "\"" o1 "\" [label = \"" c1 "\\n" object[o1] "\"];"; 
	  print "\"" o2 "\" [label = \"" c2 "\\n" object[o2] "\"];"; 
	  print "\"" o1 "\" -> \"" o2 "\";"; 
	}
    }
  print "}";
}
